chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
  let interval;

  if (request.action === "copyHtml") {
    if (window.location.pathname && window.location.pathname !== '/') {
      sendResponse({ success: false, message: 'Debes estar en la página de Inicio de Biwenger para poder usar esta opción.' });
      return true;
    }

    scrollAndCopyHTML(sendResponse, interval);
    return true;
  }

  if (request.action === "copyLeagueData") {
    if (window.location.pathname !== '/league') {
      sendResponse({ success: false, message: 'Debes estar en la página de Liga de Biwenger para poder usar esta opción.' });
      return true;
    }

    copyHtml(sendResponse);
    return true;
  }

  if (request.action === "stop") {
    stopScroll(sendResponse, interval);
    return true;
  }
});

function scrollAndCopyHTML(sendResponse, scrollInterval) {
  function findWelcomePost() {
    return Array.from(document.querySelectorAll('league-board-post h3.post-title')).find(
      el => el.textContent.includes('Bienvenid@ a')
    );
  }

  function scrollDown() {
    scrollInterval = setInterval(() => {
      window.scrollTo(0, document.body.scrollHeight);

      const welcomePost = findWelcomePost();

      if (welcomePost) {
        const content = '<body>' + document.body.innerHTML + '</body>';
        chrome.runtime.sendMessage({ action: "sendData", payload: content }, (response) => {
          sendResponse({ success: true });
          clearInterval(scrollInterval);
        });
      }
    });
  }

  scrollDown();
}

function copyHtml(sendResponse) {
  const content = '<body>' + document.body.innerHTML + '</body>';
  chrome.runtime.sendMessage({ action: "sendData", payload: content }, (response) => {
    sendResponse({ success: true });
  });
}

function stopScroll(sendResponse, scrollInterval) {
  clearInterval(scrollInterval);
  sendResponse({ success: false, message: 'No se encontró el post de bienvenida, scroll detenido' });
}

