const handleClick = async (action) => {
  const [tab] = await chrome.tabs.query({ active: true, currentWindow: true });
  const status = document.getElementById('status');
  
  if (action === "copyHtml") {
    status.classList.remove('error');
    status.textContent = 'Buscando el post de bienvenida...';
  }
  
  chrome.tabs.sendMessage(tab.id, { action }, (response) => {
    if (chrome.runtime.lastError) {
      status.classList.add('error');
      status.textContent = 'Error: ' + chrome.runtime.lastError.message;
    } else if (response.success) {
      status.classList.remove('error');
      status.textContent = '¡Contenido HTML copiado al portapapeles!';
    } else {
      status.classList.add('error');
      status.textContent = response.message || 'Error desconocido';
    }
  });
}

document.getElementById('copyButtonHtml').addEventListener('click', () => handleClick("copyHtml"));
document.getElementById('copyButtonLeagueData').addEventListener('click', () => handleClick("copyLeagueData"));

